constant float4 std709R = float4( 1.793,1.164383, 0.000000,0.0);
constant float4 std709G = float4(-0.534,1.164383,-0.213,0.0);
constant float4 std709B = float4( 0.000000,1.164383, 2.115,0.0);
constant float4 stdbias = float4(-0.5  , -0.0625,  -0.5   ,0.0);

fragment float4 fragmentFunc(inputVertexType in [[stage_in]]
                                 ,texture2d<half> inputTex0 [[ texture(0) ]]
                                 ,texture2d<half> inputTex1 [[ texture(1) ]]
                                 ,texture2d<half> inputTex2 [[ texture(2) ]]
                                 ,texture2d<half> inputTex3 [[ texture(3) ]]
                                 ,texture2d<half> maskTex [[ texture(4) ]]
                                 ,constant planarUniforms& uniforms[[ buffer(0) ]]
)
{
    vec4 yuvIn;

    yuvIn.g = textureFetchNearest(inputTex0, in.texCoordY).r;
    yuvIn.b = textureFetchNearest(inputTex1, in.texCoordUV).r;
    yuvIn.r = textureFetchNearest(inputTex2, in.texCoordUV).r;
    
#ifdef HAS_ALPHA
    yuvIn.a = textureFetchNearest(inputTex3, in.texCoordY).r;
#endif

#ifdef IS_10BIT
    yuvIn*=float4(64.0, 64.0, 64.0, 64.0);;
#endif
    
#ifdef IS_12BIT
    yuvIn*=float4(16.0, 16.0, 16.0, 16.0);
#endif
    
    yuvIn+=stdbias;

#ifndef HAS_ALPHA
    yuvIn.a=1.0;
#endif
    
    
    float4 outColor=vec4(dot(std709R, yuvIn),
                  dot(std709G, yuvIn),
                  dot(std709B, yuvIn),
                  yuvIn.a);

#ifndef NO_PREMULT
    outColor.rgb*=outColor.a;
#endif

#ifdef USE_MASK
    outColor.a*=textureFetchNearest(maskTex,in.maskCoord).a;
#endif

#ifdef USE_END_COLOR
    outColor=mix(uniforms.endColor,outColor,uniforms.endOpacity);
#endif

    return outColor;
}
