#version 330

uniform  sampler2DRect inputTex0;
uniform vec4 endColor;
uniform float endOpacity;



in vec2 fsTexture;
out vec4 outColor;

void main()
{
    outColor=texture(inputTex0, fsTexture).rrrr;

#ifdef FORCE_ALPHA
    outColor.a=1.0;
#endif

#ifndef NO_PREMULT
    outColor.rgb*=outColor.a;
#endif

#ifdef USE_MASK
    outColor.a*=texture(inputTexMask,in.maskCoord).a;
#endif

#ifdef USE_END_COLOR
    outColor=mix(endColor,outColor,endOpacity);
#endif

}
