#version 330

uniform sampler2DRect inputTex;
uniform sampler2DRect maskTex;
uniform float transitionProgress=1.0;
uniform float transitionProgressLinear=1.0;
uniform float transitionAlpha=1.0;
uniform float baseAlpha=1.0;
uniform vec4 burnColor;

in vec2 fsTexture;
in vec2 fsTextureSize;
in vec2 fsMaskTexture;
in vec2 fsTextureNormalized;
in float fsMix;
in float fsABSelect;

out vec4 outColor;

uniform float speed=1.;
uniform float angle=2.;
uniform float power=2.;

void main()
{
    vec2 p = fsTextureNormalized;
	
    float t = pow(transitionProgressLinear, power)*speed;
    p = p -0.5;
    for (int i = 0; i < 7; i++)
    {
        p = vec2(sin(t)*p.x + cos(t)*p.y, sin(t)*p.y - cos(t)*p.x);
        t += angle;
        p = abs(mod(p, 2.0) - 1.0);
    }
    abs(mod(p, 1.0));
	
	
	vec4 colorA=texture(inputTex,fsTexture);
    float texelAlpha=colorA.a;
	vec4 colorB=colorA*transitionAlpha*baseAlpha;

	vec4 colorA2=texture(inputTex,p*fsTextureSize);

	colorA=mix(colorA,colorA2,1.0 - 2.0*abs(transitionProgressLinear - 0.5));

	
	outColor=mix(colorB,colorA,fsABSelect)*texelAlpha*fsMix;
#ifdef USE_MASK
	outColor.a*=texture(maskTex,fsMaskTexture).a;
#endif
}
